"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Authentication = void 0;
const auth_configuration_models_options_model_1 = require("./auth.configuration.models.options.model");
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_namespace_1 = require("../../../../interfaces/auth.namespace");
const auth_configuration_web2_namespace_1 = require("../namespaces/web2/auth.configuration.web2.namespace");
const auth_configuration_web3_namespace_1 = require("../namespaces/web3/auth.configuration.web3.namespace");
class _Authentication {
    constructor(config) {
        if (typeof config.enabled !== 'boolean') {
            throw new Error('enabled must be a boolean');
        }
        this.enabled = config.enabled;
        try {
            this.commonOptions = new auth_configuration_models_options_model_1._Options(config.commonOptions);
        }
        catch (error) {
            throw new Error(error.message);
        }
        if (typeof config.web2Options !== 'object' || config.web2Options === null) {
            throw new Error('web2Options must be a non-null object');
        }
        this.web2Options = config.web2Options;
        if (typeof config.web3Options !== 'object' || config.web3Options === null) {
            throw new Error('web3Options must be a non-null object');
        }
        this.web3Options = config.web3Options;
    }
}
exports._Authentication = _Authentication;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Indicates whether authentication is enabled',
        type: () => Boolean,
    }),
    __metadata("design:type", Boolean)
], _Authentication.prototype, "enabled", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Common options for authentication configuration',
        type: () => auth_configuration_models_options_model_1._Options
    }),
    __metadata("design:type", Object)
], _Authentication.prototype, "commonOptions", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Web2 authentication configuration',
        type: () => auth_configuration_web2_namespace_1._Web2.Options,
    }),
    __metadata("design:type", Object)
], _Authentication.prototype, "web2Options", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Web3 authentication configuration',
        type: () => auth_configuration_web3_namespace_1._Web3.Options,
    }),
    __metadata("design:type", Object)
], _Authentication.prototype, "web3Options", void 0);
//# sourceMappingURL=auth.configuration.models.authentication.model.js.map