"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Options = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_namespace_1 = require("../../../../interfaces/auth.namespace");
const hashgraph_types_1 = require("@hsuite/hashgraph-types");
const hashgraph_types_2 = require("@hsuite/hashgraph-types");
class _Options {
    constructor(options) {
        if (typeof options.redis !== 'object' || options.redis === null) {
            throw new Error('redis must be a non-null object');
        }
        this.redis = options.redis;
        if (typeof options.jwt !== 'object' || options.jwt === null) {
            throw new Error('jwt must be a non-null object');
        }
        this.jwt = options.jwt;
        if (typeof options.cookieOptions !== 'object' || options.cookieOptions === null) {
            throw new Error('cookieOptions must be a non-null object');
        }
        this.cookieOptions = options.cookieOptions;
        if (typeof options.operator !== 'object' || options.operator === null) {
            throw new Error('operator must be a non-null object');
        }
        this.operator = options.operator;
        if (!Object.values(auth_namespace_1.IAuth.IConfiguration.IPassportStrategy).includes(options.passport)) {
            throw new Error(`passport must be a valid IPassportStrategy. Received: ${options.passport}`);
        }
        this.passport = options.passport;
        if (typeof options.appName !== 'string' || options.appName.trim() === '') {
            throw new Error('appName must be a non-empty string');
        }
        this.appName = options.appName;
    }
}
exports._Options = _Options;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Redis client options combined with cache manager configuration',
        type: () => Object,
    }),
    __metadata("design:type", Object)
], _Options.prototype, "redis", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'JWT module options for token configuration',
        type: () => Object,
    }),
    __metadata("design:type", Object)
], _Options.prototype, "jwt", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Cookie options for session management',
        type: () => Object,
    }),
    __metadata("design:type", Object)
], _Options.prototype, "cookieOptions", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Hashgraph operator configuration',
        type: () => hashgraph_types_2.Hashgraph.Operator,
    }),
    __metadata("design:type", Object)
], _Options.prototype, "operator", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Passport strategy for authentication',
        type: () => String,
        enum: auth_namespace_1.IAuth.IConfiguration.IPassportStrategy
    }),
    __metadata("design:type", String)
], _Options.prototype, "passport", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Name of the application',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Options.prototype, "appName", void 0);
//# sourceMappingURL=auth.configuration.models.options.model.js.map