"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Options = void 0;
const auth_twilio_namespace_1 = require("../../../../twilio/auth.twilio.namespace");
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
class _Options {
    constructor(options) {
        if (typeof options.confirmation_required !== 'boolean') {
            throw new Error('confirmation_required must be a boolean');
        }
        this.confirmation_required = options.confirmation_required;
        if (typeof options.admin_only !== 'boolean') {
            throw new Error('admin_only must be a boolean');
        }
        this.admin_only = options.admin_only;
        if (typeof options.sendMailOptions !== 'object' || options.sendMailOptions === null) {
            throw new Error('sendMailOptions must be an object');
        }
        if (!options.sendMailOptions.confirm || !options.sendMailOptions.reset) {
            throw new Error('sendMailOptions must contain confirm and reset properties');
        }
        this.sendMailOptions = options.sendMailOptions;
        if (typeof options.mailerOptions !== 'object' || options.mailerOptions === null) {
            throw new Error('mailerOptions must be an object');
        }
        this.mailerOptions = options.mailerOptions;
        if (typeof options.twilioOptions !== 'object' || options.twilioOptions === null) {
            throw new Error('twilioOptions must be an object');
        }
        if (!options.twilioOptions.twilioSecrets || typeof options.twilioOptions.enabled !== 'boolean') {
            throw new Error('twilioOptions must contain twilioSecrets and enabled properties');
        }
        this.twilioOptions = new auth_twilio_namespace_1._Twilio.Options(options.twilioOptions.twilioSecrets, options.twilioOptions.enabled);
    }
}
exports._Options = _Options;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: "Indicates whether email confirmation is required for authentication",
        type: () => Boolean,
    }),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], _Options.prototype, "confirmation_required", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: "Restricts authentication to admin users only when set to true",
        type: () => Boolean,
    }),
    (0, class_validator_1.IsBoolean)(),
    __metadata("design:type", Boolean)
], _Options.prototype, "admin_only", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: "Configuration for sending emails",
        type: () => Object,
    }),
    (0, class_validator_1.IsObject)(),
    (0, class_validator_1.ValidateNested)(),
    __metadata("design:type", Object)
], _Options.prototype, "sendMailOptions", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: "Configuration options for the mailer service",
        type: () => Object,
    }),
    (0, class_validator_1.IsObject)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => Object),
    __metadata("design:type", Object)
], _Options.prototype, "mailerOptions", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: "Configuration options for Twilio integration",
        type: () => auth_twilio_namespace_1._Twilio.Options,
    }),
    (0, class_validator_1.IsObject)(),
    (0, class_validator_1.ValidateNested)(),
    (0, class_transformer_1.Type)(() => auth_twilio_namespace_1._Twilio.Options),
    __metadata("design:type", auth_twilio_namespace_1._Twilio.Options)
], _Options.prototype, "twilioOptions", void 0);
//# sourceMappingURL=auth.configuration.web2.models.options.model.js.map