"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Entity = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_namespace_1 = require("../../../../../../interfaces/auth.namespace");
const auth_credentials_user_models_tags_model_1 = require("./auth.credentials.user.models.tags.model");
class _Entity {
    constructor(entity) {
        if (typeof entity.username !== 'string' || entity.username.trim() === '') {
            throw new Error('Username must be a non-empty string');
        }
        this.username = entity.username;
        if (typeof entity.email !== 'string' || !entity.email.includes('@')) {
            throw new Error('Invalid email format');
        }
        this.email = entity.email;
        if (typeof entity.created_at !== 'number' || entity.created_at <= 0) {
            throw new Error('Created_at must be a positive number');
        }
        this.created_at = entity.created_at;
        if (typeof entity.updated_at !== 'number' || entity.updated_at < entity.created_at) {
            throw new Error('Updated_at must be a number greater than or equal to created_at');
        }
        this.updated_at = entity.updated_at;
        if (!Object.values(auth_namespace_1.IAuth.ICredentials.IUser.IType).includes(entity.type)) {
            throw new Error('Invalid user type');
        }
        this.type = entity.type;
        if (!Array.isArray(entity.tags)) {
            throw new Error('Tags must be an array');
        }
        this.tags = entity.tags.map(tag => {
            if (typeof tag.key !== 'string' || typeof tag.value !== 'string') {
                throw new Error('Each tag must have a key and value of type string');
            }
            return tag;
        });
    }
}
exports._Entity = _Entity;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The unique username of the user',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Entity.prototype, "username", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The email address associated with the user account',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Entity.prototype, "email", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The timestamp (in milliseconds) when the user account was created',
        type: () => Number,
    }),
    __metadata("design:type", Number)
], _Entity.prototype, "created_at", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The timestamp (in milliseconds) when the user account was last updated',
        type: () => Number,
    }),
    __metadata("design:type", Number)
], _Entity.prototype, "updated_at", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The type of user authentication (web2 or web3)',
        enum: auth_namespace_1.IAuth.ICredentials.IUser.IType,
    }),
    __metadata("design:type", String)
], _Entity.prototype, "type", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'An array of tags associated with the user account',
        type: () => auth_credentials_user_models_tags_model_1._Tags,
        isArray: true,
    }),
    __metadata("design:type", Array)
], _Entity.prototype, "tags", void 0);
//# sourceMappingURL=auth.credentials.user.models.entity.model.js.map