"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Login = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
class _Login {
    constructor(login) {
        if (typeof login.username !== 'string' || login.username.trim() === '') {
            throw new Error('Username must be a non-empty string');
        }
        this.username = login.username;
        const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        if (typeof login.email !== 'string' || !emailRegex.test(login.email)) {
            throw new Error('Invalid email format');
        }
        this.email = login.email;
        if (typeof login.password !== 'string' || login.password.length < 8) {
            throw new Error('Password must be a string with at least 8 characters');
        }
        this.password = login.password;
    }
}
exports._Login = _Login;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The unique identifier for the user\'s account',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Login.prototype, "username", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The email address associated with the user\'s account',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Login.prototype, "email", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The secret password for authentication (should be securely hashed)',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Login.prototype, "password", void 0);
//# sourceMappingURL=auth.credentials.web2.dto.models.login.model.js.map