"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Signup = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_credentials_user_namespace_1 = require("../../../../user/auth.credentials.user.namespace");
class _Signup {
    constructor(signup) {
        if (typeof signup.username !== 'string' || signup.username.trim() === '') {
            throw new Error('Username must be a non-empty string');
        }
        this.username = signup.username;
        const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        if (typeof signup.email !== 'string' || !emailRegex.test(signup.email)) {
            throw new Error('Invalid email format');
        }
        this.email = signup.email;
        if (typeof signup.password !== 'string' || signup.password.length < 8) {
            throw new Error('Password must be a string with at least 8 characters');
        }
        this.password = signup.password;
        if (!Array.isArray(signup.tags) || signup.tags.length === 0) {
            throw new Error('Tags must be a non-empty array');
        }
        this.tags = signup.tags.map(tag => new auth_credentials_user_namespace_1._User.Tags(tag));
    }
}
exports._Signup = _Signup;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The unique identifier for the user\'s account',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Signup.prototype, "username", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The email address associated with the user\'s account',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Signup.prototype, "email", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The secret password for authentication (should be securely hashed)',
        type: () => String,
    }),
    __metadata("design:type", String)
], _Signup.prototype, "password", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'An array of tags associated with the user',
        type: () => auth_credentials_user_namespace_1._User.Tags,
        isArray: true
    }),
    __metadata("design:type", Array)
], _Signup.prototype, "tags", void 0);
//# sourceMappingURL=auth.credentials.web2.dto.models.signup.model.js.map