"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Entity = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_configuration_namespace_1 = require("../../../../configuration/auth.configuration.namespace");
class _Entity {
    constructor(entity) {
        if (typeof entity.walletId !== 'string' || entity.walletId.trim() === '') {
            throw new Error('walletId must be a non-empty string');
        }
        this.walletId = entity.walletId;
        if (typeof entity.publicKey !== 'string' || entity.publicKey.trim() === '') {
            throw new Error('publicKey must be a non-empty string');
        }
        this.publicKey = entity.publicKey;
        if (!Array.isArray(entity.balance)) {
            throw new Error('balance must be an array');
        }
    }
}
exports._Entity = _Entity;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Unique identifier for the wallet',
        type: () => String,
        example: '0x1234567890abcdef'
    }),
    __metadata("design:type", String)
], _Entity.prototype, "walletId", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Public key associated with the wallet',
        type: () => String,
        example: '0xabcdef1234567890'
    }),
    __metadata("design:type", String)
], _Entity.prototype, "publicKey", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Array of token balances for the entity',
        type: () => auth_configuration_namespace_1._Configuration.Web3.TokenGate.Entity
    }),
    __metadata("design:type", Array)
], _Entity.prototype, "balance", void 0);
//# sourceMappingURL=auth.credentials.web3.models.entity.model.js.map