"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._SignedData = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
class _SignedData {
    constructor(signature, serverSigningAccount) {
        if (!(signature instanceof Uint8Array)) {
            throw new Error('Signature must be a Uint8Array');
        }
        if (signature.length === 0) {
            throw new Error('Signature cannot be empty');
        }
        this.signature = signature;
        if (typeof serverSigningAccount !== 'string' || serverSigningAccount.trim().length === 0) {
            throw new Error('Server signing account must be a non-empty string');
        }
        this.serverSigningAccount = serverSigningAccount;
    }
}
exports._SignedData = _SignedData;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'A cryptographic signature used to verify the authenticity of the data',
        type: () => Uint8Array,
        example: new Uint8Array([1, 2, 3, 4, 5])
    }),
    __metadata("design:type", Uint8Array)
], _SignedData.prototype, "signature", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'Unique identifier for the server account that generated the signature',
        type: () => String,
        example: '0x1234567890abcdef'
    }),
    __metadata("design:type", String)
], _SignedData.prototype, "serverSigningAccount", void 0);
//# sourceMappingURL=auth.credentials.web3.request.authentication.models.signed-data.model.js.map