"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._SignedData = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_namespace_1 = require("../../../../../../../../../../interfaces/auth.namespace");
const auth_credentials_web3_request_sign_in_models_signed_payload_model_1 = require("./auth.credentials.web3.request.sign_in.models.signed-payload.model");
class _SignedData {
    constructor(signedData) {
        if (!signedData.signedPayload || typeof signedData.signedPayload !== 'object') {
            throw new Error('Signed payload must be a valid object');
        }
        this.signedPayload = signedData.signedPayload;
        if (!(signedData.userSignature instanceof Uint8Array)) {
            throw new Error('User signature must be a Uint8Array');
        }
        if (signedData.userSignature.length === 0) {
            throw new Error('User signature cannot be empty');
        }
        this.userSignature = signedData.userSignature;
    }
}
exports._SignedData = _SignedData;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The signed payload containing the server signature and original authentication payload',
        type: () => auth_credentials_web3_request_sign_in_models_signed_payload_model_1._SignedPayload
    }),
    __metadata("design:type", Object)
], _SignedData.prototype, "signedPayload", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The signature generated by the user to prove ownership of the account',
        type: () => Uint8Array,
        isArray: true
    }),
    __metadata("design:type", Uint8Array)
], _SignedData.prototype, "userSignature", void 0);
//# sourceMappingURL=auth.credentials.web3.request.sign_in.models.signed-data.model.js.map