"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Auth = void 0;
const auth_namespace_1 = require("../../../../interfaces/auth.namespace");
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
class _Auth {
    constructor(status, factorSid, identity, qr_code) {
        if (typeof status !== 'object' || status === null) {
            throw new Error('status must be a valid IAuth.ITwoFactor.IStatus object');
        }
        if (typeof factorSid !== 'string' || factorSid.trim() === '') {
            throw new Error('factorSid must be a non-empty string');
        }
        if (typeof identity !== 'string' || identity.trim() === '') {
            throw new Error('identity must be a non-empty string');
        }
        if (typeof qr_code !== 'string' || qr_code.trim() === '') {
            throw new Error('qr_code must be a non-empty string');
        }
        this.status = status;
        this.factorSid = factorSid;
        this.identity = identity;
        this.qr_code = qr_code;
    }
}
exports._Auth = _Auth;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        type: () => String,
        enum: auth_namespace_1.IAuth.ITwoFactor.IStatus,
        description: 'The current status of the Two-Factor Authentication',
        example: 'PENDING'
    }),
    __metadata("design:type", String)
], _Auth.prototype, "status", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        type: () => String,
        description: 'Unique identifier for the Two-Factor Authentication factor',
        example: 'YF1234567890abcdef1234567890abcdef'
    }),
    __metadata("design:type", String)
], _Auth.prototype, "factorSid", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        type: () => String,
        description: 'The identity associated with this Two-Factor Authentication',
        example: 'user@example.com'
    }),
    __metadata("design:type", String)
], _Auth.prototype, "identity", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        type: () => String,
        description: 'The QR code for setting up Two-Factor Authentication',
        example: 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgA...'
    }),
    __metadata("design:type", String)
], _Auth.prototype, "qr_code", void 0);
//# sourceMappingURL=auth.two_factor.models.model.js.map