"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Create = void 0;
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
class _Create {
    constructor(factorSid, identity, uri, secret, message) {
        if (typeof factorSid !== 'string' || factorSid.trim() === '') {
            throw new Error('factorSid must be a non-empty string');
        }
        if (typeof identity !== 'string' || identity.trim() === '') {
            throw new Error('identity must be a non-empty string');
        }
        if (typeof uri !== 'string' || uri.trim() === '') {
            throw new Error('uri must be a non-empty string');
        }
        if (typeof secret !== 'string' || secret.trim() === '') {
            throw new Error('secret must be a non-empty string');
        }
        if (typeof message !== 'string') {
            throw new Error('message must be a string');
        }
        this.factorSid = factorSid;
        this.identity = identity;
        this.uri = uri;
        this.secret = secret;
        this.message = message;
    }
}
exports._Create = _Create;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The unique identifier for the created factor',
        type: () => String,
        example: 'YF1234567890abcdef1234567890abcdef'
    }),
    __metadata("design:type", String)
], _Create.prototype, "factorSid", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The identity associated with the two-factor authentication',
        type: () => String,
        example: 'user@example.com'
    }),
    __metadata("design:type", String)
], _Create.prototype, "identity", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The URI for the two-factor authentication, typically used for QR code generation',
        type: () => String,
        example: 'otpauth://totp/Example:user@example.com?secret=JBSWY3DPEHPK3PXP'
    }),
    __metadata("design:type", String)
], _Create.prototype, "uri", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The secret key used for two-factor authentication',
        type: () => String,
        example: 'JBSWY3DPEHPK3PXP'
    }),
    __metadata("design:type", String)
], _Create.prototype, "secret", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'A message providing additional information about the creation process',
        type: () => String,
        example: 'Two-factor authentication created successfully'
    }),
    __metadata("design:type", String)
], _Create.prototype, "message", void 0);
//# sourceMappingURL=auth.two_factor.response.models.create.model.js.map