"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Payload = void 0;
const auth_credentials_web3_request_authentication_models_data_model_1 = require("./auth.credentials.web3.request.authentication.models.data.model");
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_namespace_1 = require("../../../../../../../../../../interfaces/auth.namespace");
class _Payload {
    constructor(payload) {
        if (!payload.url || typeof payload.url !== 'string') {
            throw new Error('URL must be a non-empty string');
        }
        try {
            new URL(payload.url);
        }
        catch (error) {
            throw new Error('Invalid URL format');
        }
        if (!payload.node || typeof payload.node !== 'string') {
            throw new Error('Node must be a non-empty string');
        }
        if (!payload.data || typeof payload.data !== 'object' || !payload.data.token) {
            throw new Error('Invalid data object');
        }
        this.url = payload.url;
        this.node = payload.node;
        this.data = new auth_credentials_web3_request_authentication_models_data_model_1._Data(payload.data.token);
    }
}
exports._Payload = _Payload;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The URL associated with the authentication request',
        example: 'https://example.com/auth'
    }),
    __metadata("design:type", String)
], _Payload.prototype, "url", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The identifier of the node handling the authentication',
        example: 'node-1'
    }),
    __metadata("design:type", String)
], _Payload.prototype, "node", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The authentication data',
        type: () => auth_credentials_web3_request_authentication_models_data_model_1._Data
    }),
    __metadata("design:type", Object)
], _Payload.prototype, "data", void 0);
//# sourceMappingURL=auth.credentials.web3.request.authentication.models.payload.model.js.map