"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._SignedPayload = void 0;
const auth_credentials_web3_request_authentication_namespace_1 = require("../../authentication/auth.credentials.web3.request.authentication.namespace");
const nestjs_swagger_1 = require("@hsuite/nestjs-swagger");
const auth_namespace_1 = require("../../../../../../../../../../interfaces/auth.namespace");
class _SignedPayload {
    constructor(signedPayload) {
        if (!(signedPayload.serverSignature instanceof Uint8Array)) {
            throw new Error('Server signature must be a Uint8Array');
        }
        if (signedPayload.serverSignature.length === 0) {
            throw new Error('Server signature cannot be empty');
        }
        this.serverSignature = signedPayload.serverSignature;
        if (!(signedPayload.originalPayload instanceof auth_credentials_web3_request_authentication_namespace_1._Authentication.Payload)) {
            throw new Error('Original payload must be an instance of Auth.Credentials.Web3.Request.Authentication.Payload');
        }
        this.originalPayload = signedPayload.originalPayload;
    }
}
exports._SignedPayload = _SignedPayload;
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The signature generated by the server to verify the payload',
        type: () => Uint8Array,
        isArray: true
    }),
    __metadata("design:type", Uint8Array)
], _SignedPayload.prototype, "serverSignature", void 0);
__decorate([
    (0, nestjs_swagger_1.ApiProperty)({
        description: 'The original authentication payload that was signed',
        type: () => auth_credentials_web3_request_authentication_namespace_1._Authentication.Payload
    }),
    __metadata("design:type", Object)
], _SignedPayload.prototype, "originalPayload", void 0);
//# sourceMappingURL=auth.credentials.web3.request.sign_in.models.signed-payload.model.js.map